

interface axis (input logic aclk);

    logic [15:0] tdata;
    logic        tvalid;
    logic        tready;
    

    // clocking block for AXI Stream master
    clocking cb_axis_mst @(posedge aclk);
      default input #1step output #3ns;
      output  tdata;
      output  tvalid;
      input   tready;
    endclocking
      
      

    // clocking block for AXI Stream slave
    clocking cb_axis_slv @(posedge aclk);
      default input #1step output #2ns;
      input   tdata;
      input   tvalid;
      output  tready;
    endclocking

     

    // AXI stream master modport - for testbench only
    modport tb_axis_mst_mp(clocking cb_axis_mst,
                           output tdata,
                           output tvalid,
                           input  tready );

    // AXI stream slave modport - for testbench only
    modport tb_axis_slv_mp(clocking cb_axis_slv,
                           input   tdata,
                           input   tvalid,
                           output  tready );
    
    
    // AXI stream master modport - for synthesis
    modport axis_mst_mp(
        output tdata,
        output tvalid,
        input  tready );
    
    // AXI stream slave modport - for synthesis
    modport axis_slv_mp(
        input  tdata,
        input  tvalid,
        output tready);
    


endinterface: axis

