
/*----------------------------------------------------
Author  : Mark Harvey
Created : 11.01.2016
Version : 1.0

test driver

----------------------------------------------------*/

`timescale 1ps/1ps
`include "axis_if.vh"


module test_driver(
    output  logic        ARESETN = 0,    
    axis.tb_axis_mst_mp  AXIS_MST       // AXI stream interface, master modport
    );
  
  /*----------------------------------------------------
   Test Driver
  ----------------------------------------------------*/     
 
  initial begin
    
    // release reset
    ARESETN = 0;
    #200ns ARESETN = 1;
    
    @(AXIS_MST.cb_axis_mst);
      
    for (int i=0; i<10; i++) begin
      @(AXIS_MST.cb_axis_mst);
      AXIS_MST.cb_axis_mst.tvalid <= 1;
      AXIS_MST.cb_axis_mst.tdata <= i;
      do
        @(AXIS_MST.cb_axis_mst);
      while (AXIS_MST.cb_axis_mst.tready == 0);
      AXIS_MST.cb_axis_mst.tvalid <= 0;
      AXIS_MST.cb_axis_mst.tdata  <= 16'h0000;   
    end
   
  end  
   

endmodule : test_driver
/*----------------------------------------------------
 End of file: test_driver.sv
----------------------------------------------------*/