
/*----------------------------------------------------
Author  : Mark Harvey
Created : 11.01.2016
Version : 1.0

test receiver

----------------------------------------------------*/

`timescale 1ps/1ps
`include "axis_if.vh"


module test_receiver(
    axis.tb_axis_slv_mp   AXIS_SLV    // AXI stream interface, slave modport
    );
   
   
  /*----------------------------------------------------
   Test receiver
   Handshaking on  AXI master interface.
   Assert tready to complete transfer.
  ----------------------------------------------------*/    
 
  initial begin
    automatic integer unsigned respDelay;      
     
    AXIS_SLV.cb_axis_slv.tready <= 0;
     
    do begin
     
      respDelay = $urandom_range(1,10);
       
      // wait for TVALID high
      do begin
        @(AXIS_SLV.cb_axis_slv);
      end while (AXIS_SLV.cb_axis_slv.tvalid == 0);
       
      // wait a random number of clock cycles before responding
      repeat (respDelay) begin
        @(AXIS_SLV.cb_axis_slv);
      end
       
      AXIS_SLV.cb_axis_slv.tready <= 1;
      @(AXIS_SLV.cb_axis_slv);
      AXIS_SLV.cb_axis_slv.tready <= 0;
     
    end while(1);

  end  

  

endmodule : test_receiver
/*----------------------------------------------------
 End of file: test_receiver.sv
----------------------------------------------------*/